module MyPrelude where

import UnsafePerformIO

lookupall x [] = ([],[])
lookupall x ((z@(y,u)):rs) = 
 let (as,bs) = lookupall x rs
 in if x == y 
       then (z:as,bs)
       else (as,z:bs)

sift p [] = ([],[])
sift p (x:xs) =
 let (ys,zs) = sift p xs
 in if p x 
       then (x:ys,zs)
       else (ys,x:zs)

mapAccuml :: (a -> b -> (a,c)) -> a -> [b] -> (a,[c])
mapAccuml f acc [] = (acc,[])
mapAccuml f acc (x:xs) = (acc2,x':xs')
                         where (acc1,x') = f acc x
                               (acc2,xs') = mapAccuml f acc1 xs


myTrace :: String -> a -> a
myTrace mssg prg =
   let put = unsafePerformIO (putStrLn mssg)
   in seq put prg
