module Axioms where

import AbsSyntax


type AxiomTyp = [(Name,Name)]
type AxiomIncl =[(Name,Name)]

sType = ESort "Type"
sKind = ESort "Kind"
sSet = ESort "Set"

topsort = sKind
minsort = sSet

{- *********** Framework with Type and Kind *********** -}
{-
initAxTyp  = [("Type","Kind")]
initAxIncl = [("Type","Type"),("Type","Kind"),("Kind","Kind")]
-}

{- ********** Framework with Set and type families ********** -}


initAxTyp = [("Set","Type"),("Set","Kind"),("Type","Kind")]
initAxIncl = [("Set","Set"),("Set","Type"), ("Set","Kind"),
              ("Type","Type"),("Type","Kind"),
              ("Kind","Kind")]

